<?php
/**
 * Plugin Name: Deagor | WMS for Humans
 * Plugin URI: http://deagor.io
 * Description: Deagor plugin.
 * Version: 1.1.2
 * Author: DF SRL
 * Author URI: http://deagor.io
 * Requires at least: 4.5.0
 * Tested up to: 5.3
 *
 * Text Domain: deagor
 * Domain Path: /languages/
 *
 * @package deagor
 * @category Core
 * @author Deagor SRLS
 */
	if ( ! defined( 'ABSPATH' ) ) {
	    exit; // Exit if accessed directly
	}

	register_activation_hook(__FILE__, 'deagor_activate');

	add_action('init', 'deagor_init');
	add_action('plugins_loaded', 'deagor_bootstrap');


	function deagor_activate() {
	    if (!class_exists('WooCommerce')) {
	        return;
	    }
	}

	function deagor_init() {
	    if (!class_exists('WooCommerce')) {
	        return;
	    }
	    load_plugin_textdomain('deagor', false, basename( dirname( __FILE__ ) ) . '/languages/' );
	}

	function deagor_bootstrap() {
	    if (!class_exists('WooCommerce')) {
	        require_once(ABSPATH . '/wp-admin/includes/plugin.php');
	        deactivate_plugins(plugin_basename(__FILE__));
	        add_action('admin_notices', 'deagor_deactivate_notice');
	    } else {
		    add_filter('woocommerce_get_sections_advanced', 'deagor_add_section' );
	    }
	}


	function deagor_add_section( $sections ) {
		$sections['deagor'] = __( 'Deagor', 'deagor' );
		return $sections;
	}


	add_filter( 'woocommerce_get_settings_advanced', 'deagor_all_settings', 10, 2 );
	function deagor_all_settings($settings,$current_section) {

		if ($current_section == 'deagor') {
			$settings_deagor = array();

			$_attribute = getAttribute();

			$_orderStatus[] = '-- Seleziona Stato --';
			foreach (wc_get_order_statuses() as $key => $status){
				$_orderStatus[$key]	= $status;
			}
			$permalinks_enabled = get_option('permalink_structure');

			if ($permalinks_enabled) {

				$settings_deagor[] = array(
						'name' => __( 'Deagor', 'deagor' ),
						'type' => 'title',
						'desc' => __( 'The following options are used to configure Deagor.<br><b style="color:red">ATTENTION 1*: Only product with SKU will be imported.</b><br><b style="color:red">ATTENTION 2*: If product has Variation and not have SKU Variation will be imported with this syntax : PRODUCTSKU_VARIATION.</b>', 'deagor' ),
						'id' => 'wcslider'
				);

				$settings_deagor[] = array(
					'name'     => __( 'Enable Deagor', 'deagor' ),
					'desc_tip' => __( 'Enable Deagor', 'deagor' ),
					'id'       => 'deagor_enable',
					'type'     => 'select',
					'desc'     => __( 'Enable Deagor', 'deagor' ),
					'options'	=> array('1'=>'Yes','0'=>'No'),
				);

				$settings_deagor[] = array(
					'name'     => __( 'EndPoint', 'deagor' ),
					'desc_tip' => __( 'Deagor Endpoint.', 'deagor' ),
					'id'       => 'deagor_endpoint',
					'type'     => 'text',
					'desc'     => __( 'Deagor Endpoint', 'deagor' ),
				);

				$settings_deagor[] = array(
					'name'     => __( 'Token', 'deagor' ),
					'desc_tip' => __( 'Deagor Token.', 'deagor' ),
					'id'       => 'deagor_token',
					'type'     => 'text',
					'desc'     => __( 'Deagor Token', 'deagor' ),
				);

				$settings_deagor[] = array(
					'name'     => __( 'Cost Attribute', 'deagor' ),
					'desc_tip' => __( 'Cost Attribute', 'deagor' ),
					'id'       => 'deagor_cost',
					'type'     => 'select',
					'desc'     => __( 'Cost Attribute.', 'deagor' ),
					'options'	=> $_attribute,
				);

				$settings_deagor[] = array(
					'name'     => __( 'Volume Attribute', 'deagor' ),
					'desc_tip' => __( 'Volume Attribute', 'deagor' ),
					'id'       => 'deagor_volume',
					'type'     => 'select',
					'desc'     => __( 'Volume Attribute. If not present is calculated from : LxWxH in shipping Field.', 'deagor' ),
					'options'	=> $_attribute,
				);

				$settings_deagor[] = array(
					'name'     => __( 'Model Attribute', 'deagor' ),
					'desc_tip' => __( 'Model Attribute', 'deagor' ),
					'id'       => 'deagor_model',
					'type'     => 'select',
					'desc'     => __( 'Model Attribute', 'deagor' ),
					'options'	=> $_attribute,
				);

				$settings_deagor[] = array(
					'name'     => __( 'EAN Attribute', 'deagor' ),
					'desc_tip' => __( 'EAN Attribute', 'deagor' ),
					'id'       => 'deagor_ean',
					'type'     => 'select',
					'desc'     => __( 'EAN Attribute', 'deagor' ),
					'options'	=> $_attribute,
				);

				$settings_deagor[] = array(
					'name'     => __( 'Supplier Code 1 Attribute', 'deagor' ),
					'desc_tip' => __( 'Supplier Code 1 Attribute', 'deagor' ),
					'id'       => 'deagor_forn1',
					'type'     => 'select',
					'desc'     => __( 'Supplier Code 1 Attribute', 'deagor' ),
					'options'	=> $_attribute,
				);

				$settings_deagor[] = array(
					'name'     => __( 'Supplier Code 2 Attribute', 'deagor' ),
					'desc_tip' => __( 'Supplier Code 2 Attribute', 'deagor' ),
					'id'       => 'deagor_forn2',
					'type'     => 'select',
					'desc'     => __( 'Supplier Code 2 Attribute', 'deagor' ),
					'options'	=> $_attribute,
				);

				$settings_deagor[] = array(
					'name'     => __( 'Supplier Code 3 Attribute', 'deagor' ),
					'desc_tip' => __( 'Supplier Code 3 Attribute', 'deagor' ),
					'id'       => 'deagor_forn3',
					'type'     => 'select',
					'desc'     => __( 'Supplier Code 3 Attribute', 'deagor' ),
					'options'	=> $_attribute,
				);

				$settings_deagor[] = array(
					'name'     => __( 'Supplier Code 4 Attribute', 'deagor' ),
					'desc_tip' => __( 'Supplier Code 4 Attribute', 'deagor' ),
					'id'       => 'deagor_forn4',
					'type'     => 'select',
					'desc'     => __( 'Supplier Code 4 Attribute', 'deagor' ),
					'options'	=> $_attribute,
				);

				$settings_deagor[] = array(
					'name'     => __( 'Days to Sync orders', 'deagor' ),
					'desc_tip' => __( 'Days to Sync orders', 'deagor' ),
					'id'       => 'deagor_daytosync',
					'type'     => 'select',
					'desc'     => __( 'Days to Sync orders', 'deagor' ),
					'options'	=> daytosync(),
				);

				$settings_deagor[] = array(
					'name'     => __( 'Send Status', 'deagor' ),
					'desc_tip' => __( 'Select the state in which you have to find the order to be sent to the Deagor.', 'deagor' ),
					'id'       => 'deagor_statussend',
					'type'     => 'multiselect',
					'desc'     => __( 'Select the state in which you have to find the order to be sent to the Deagor.', 'deagor' ),
					'options'	=> wc_get_order_statuses(),
				);

				$settings_deagor[] = array(
					'name'     => __( 'Shipped Status', 'deagor' ),
					'desc_tip' => __( 'Shipped Status', 'deagor' ),
					'id'       => 'deagor_shipped',
					'type'     => 'select',
					'desc'     => __( 'Select status of Order when is shipped', 'deagor' ),
					'options'	=> $_orderStatus,
				);

				$settings_deagor[] = array(
					'name'     => __( 'Shipped + Tracking Status', 'deagor' ),
					'desc_tip' => __( 'Shipped + Tracking Status', 'deagor' ),
					'id'       => 'deagor_tracked',
					'type'     => 'select',
					'desc'     => __( 'Select status of Order when is shipped and have a tracking number', 'deagor' ),
					'options'	=> $_orderStatus,
				);

			} else {

				$settings_deagor[] = array(
						'name' => __( 'Deagor', 'deagor' ),
						'type' => 'title',
						'desc' => __( 'You need to enable permalinks. On Settings -> <a style="color:red" href="/wp-admin/options-permalink.php">Permalinks</a>.', 'deagor' ),
						'id' => 'wcslider'
				);

			}

			$settings_deagor[] = array( 'type' => 'sectionend', 'id' => 'deagor' );

			return $settings_deagor;

		} else {
			return $settings;
		}
	}

	function getAttribute(){
		$query_args = array(
		    'limit'     => -1,
		);

		$data = array('0'=> '-- Select Attribute --');
		foreach( wc_get_products($query_args) as $product ){
		    foreach( $product->get_attributes() as $taxonomy => $attribute){
		        $attribute_name = wc_attribute_label($taxonomy);
		        $data[$taxonomy] = $attribute_name;
		        /*// Or: $attribute_name = get_taxonomy( $taxonomy )->labels->singular_name;
		        foreach ( $attribute->get_terms() as $term ){
		            $data[$taxonomy][$term->term_id] = $term->name;
		            // Or with the product attribute label name instead:
		            // $data[$attribute_name][$term->term_id] = $term->name;
		        }*/
		    }
		}
		if (function_exists('wpm_product_gtin_wc')) {
			$data['wpm_gtin_code'] = 'Product GTIN - Plugin';
		}
		if(class_exists('Woo_GTIN')) {
			$data['hwp_product_gtin'] = 'WooCommerce UPC, EAN, and ISBN - Plugin';
		}
		if(class_exists('Alg_WC_EAN')) {
			$data['variable_alg_ean_1'] = 'EAN Barcode Generator for WooCommerce: UPC, ISBN & GTIN Inventory - Plugin';
		}
		return $data;
	}

	function daytosync() {
		$_return = array();
		for( $i=1; $i<=90; $i++ ) {
			$_return[$i] = $i.' Days';
		}
		return $_return;
	}


	function deagor_deactivate_notice() {
	    $message = __(
	        'Deagor | WMS for Humans plugin deactivated itself because WooCommerce is not available.',
	        'deagor');
	    printf('<div class="error"><p>%s</p></div>', $message);
	}

	function canAccess($_params){
		if (!get_option('deagor_enable')){
			return;
		}
		if ((!$_params['token']) || ($_params['token'] != get_option('deagor_token'))){
			return;
		} else {
			return true;
		}
	}

	add_action('rest_api_init', function () {
	register_rest_route( 'deagor/v1', 'oauth',array(
                'methods'  => 'POST',
                'callback' => 'oauth'
			));
	});

	function oauth($request) {
		$_params = $request->get_params();
		if (!canAccess($_params)){
			$_return['status']	= 2;
			$_return['error'] 	= array(
					'code' 		=> 'ER03',
					'message'	=> 'Token error'
				);
		} else {
			$_return['status']	= 1;
			$_return['data']	= 1;
		}
		$response = new WP_REST_Response($_return);
	    $response->set_status(200);

	    return $response;
	}

	add_action('rest_api_init', function () {
		register_rest_route( 'deagor/v1', 'getStock',array(
			'methods'  => 'POST',
			'callback' => 'getStock'
		));
	});

	function getStock($request) {
		$_params = $request->get_params();
		$_params = json_decode($_params['params'], true);
		if (!canAccess($_params)){
			$_return['status']	= 2;
			$_return['error'] 	= array(
					'code' 		=> 'ER01',
					'message'	=> 'Token error'
				);
			$response = new WP_REST_Response($_return);
		    $response->set_status(200);
		    return $response;
		} else {
			$_return['status']	= 1;
		}
		if (!$_params['channel_product_id']){
			$_return['error'] 	= array(
				'code' 		=> 'ER02',
				'message'	=> 'channel_product_id not found'
			);
			$response = new WP_REST_Response($_return);
			$response->set_status(200);
			return $response;
		}
		$product = wc_get_product($_params['channel_product_id']);
		if (!$product) {
			if ($productId = wc_get_product_id_by_sku($_params['sku'])) {
				$product = wc_get_product($productId);
			}
		}
		if (!$product) {
			$_return['error'] 	= array(
				'code' 		=> 'ER02',
				'message'	=> 'Product not found'
			);
			$response = new WP_REST_Response($_return);
			$response->set_status(200);
			return $response;
		}

		if ($product->managing_stock()){
			$currentStock = $product->get_stock_quantity();
		} else {
			$currentStock = 'Stock non gestito';
		}

		$_return = [
			'status' => 1,
			'data' => [
				'quantity' => $currentStock,
			]
		];

		$_data = json_encode($_return['data']);
		$_return['data'] = array();
		$_return['data'] = $_data;

		$response = new WP_REST_Response($_return);
	    $response->set_status(200);

	    return $response;

	}

	add_action('rest_api_init', function () {
		register_rest_route( 'deagor/v1', 'setStock',array(
			'methods'  => 'POST',
			'callback' => 'setProductStock'
		));
	});

	function setProductStock($request) {
		$_params = $request->get_params();
		$_params = json_decode($_params['params'], true);
		if (!canAccess($_params)){
			$_return['status']	= 2;
			$_return['error'] 	= array(
					'code' 		=> 'ER01',
					'message'	=> 'Token error'
				);
			$response = new WP_REST_Response($_return);
		    $response->set_status(200);
		    return $response;
		} else {
			$_return['status']	= 1;
		}

		$product = wc_get_product($_params['channel_product_id']);
		if (!$product) {
			if ($productId = wc_get_product_id_by_sku($_params['sku'])) {
				$product = wc_get_product($productId);
			}
		}

		if (!$product) {
			$_return['error'] 	= array(
				'code' 		=> 'ER02',
				'message'	=> 'Product not found'
			);
			$response = new WP_REST_Response($_return);
			$response->set_status(200);
			return $response;
		}

		$currentStock = $product->get_stock_quantity();
		$newQty = $currentStock + intval($_params['add_new_stock']);
		wc_update_product_stock($product->get_id(), $newQty);

		$_return = [
			'status' => 1,
			'data' => [
				'oldstock' => $currentStock,
				'newstock' => $newQty
			]
		];

		$_data = json_encode($_return['data']);
		$_return['data'] = array();
		$_return['data'] = $_data;

		$response = new WP_REST_Response($_return);
	    $response->set_status(200);

	    return $response;
	}






	add_action('rest_api_init', function () {
		register_rest_route( 'deagor/v1', 'replaceStock',array(
			'methods'  => 'POST',
			'callback' => 'setreplaceStock'
		));
	});

	function setreplaceStock($request) {
		$_params = $request->get_params();
		$_params = json_decode($_params['params'], true);
		if (!canAccess($_params)){
			$_return['status']	= 2;
			$_return['error'] 	= array(
					'code' 		=> 'ER01',
					'message'	=> 'Token error'
				);
			$response = new WP_REST_Response($_return);
		    $response->set_status(200);
		    return $response;
		} else {
			$_return['status']	= 1;
		}

		$product = wc_get_product($_params['channel_product_id']);
		if (!$product) {
			if ($productId = wc_get_product_id_by_sku($_params['sku'])) {
				$product = wc_get_product($productId);
			}
		}

		if (!$product) {
			$_return['error'] 	= array(
				'code' 		=> 'ER02',
				'message'	=> 'Product not found'
			);
			$response = new WP_REST_Response($_return);
			$response->set_status(200);
			return $response;
		}

		$currentStock = $product->get_stock_quantity();
		$newQty = $_params['add_new_stock'];
		wc_update_product_stock($product->get_id(), $newQty);

		$_return = [
			'status' => 1,
			'data' => [
				'oldstock' => $currentStock,
				'newstock' => $newQty
			]
		];

		$_data = json_encode($_return['data']);
		$_return['data'] = array();
		$_return['data'] = $_data;

		$response = new WP_REST_Response($_return);
	    $response->set_status(200);

	    return $response;
	}


	add_action('rest_api_init', function () {
	register_rest_route( 'deagor/v1', 'updateAddress',array(
                'methods'  => 'POST',
                'callback' => 'updateAddress'
			));
	});

	function updateAddress($request) {

		$_params = $request->get_params();
		$_params = json_decode($_params['params'], true);
		if (!canAccess($_params)){
			$_return['status']	= 2;
			$_return['error'] 	= array(
					'code' 		=> 'ER03',
					'message'	=> 'Token error'
				);
			$response = new WP_REST_Response($_return);
		    $response->set_status(200);
		    return $response;
		} else {
			$_return['status']	= 1;
		}

		$_return['data']	= array('success' => false, 'message' => '');

	    $_orderId			= @$_params['ecommerce_id'];
		$_address 			= @$_params['address'];

	    if (($_orderId) && ($_address)){

		    $query_args = array(
			    'limit' 	=> get_option('posts_per_page'),
			    'page' 		=> 1,
			    'post__in' 	=> array($_orderId),
			);

			$_collection = wc_get_orders($query_args);

		    if ($_collection){

				$order = new WC_Order($_orderId);

			    $_newAddress = $_params['address'];

				update_post_meta( $_orderId, '_shipping_first_name', $_newAddress['firstname'] );
				update_post_meta( $order->ID, '_shipping_last_name', $_newAddress['lastname'] );
				update_post_meta( $order->ID, '_shipping_company', $_newAddress['company'] );
				update_post_meta( $order->ID, '_shipping_address_1', $_newAddress['street_1'].' '.$_newAddress['number']);
				update_post_meta( $order->ID, '_shipping_address_2', '');
				update_post_meta( $order->ID, '_shipping_city', $_newAddress['city']);
				update_post_meta( $order->ID, '_shipping_state', $_newAddress['region_code']);
				update_post_meta( $order->ID, '_shipping_postcode', $_newAddress['postcode']);
				update_post_meta( $order->ID, '_shipping_country', $_newAddress['country_iso2']);
				update_post_meta( $order->ID, '_billing_phone', $_newAddress['mobile']);
				if ($_newAddress['notes']){
					$order_note = array(
					    'order_id' => $_orderId,
					    'customer_note' => $_newAddress['notes']
					);
					wc_update_order($order_note);
				}

			    $_return['data']['success'] = true;
			    $_return['data']['message'] = 'Order address was update successful';

		    } else {
			    $_return['data']['message'] = 'No Product found';
		    }

	    } else {
		    $_return['data']['message'] = "Order ID and 'address' params are required.";
	    }

		$_data = json_encode($_return['data']);
		$_return['data'] = array();
		$_return['data'] = $_data;

		$response = new WP_REST_Response($_return);
	    $response->set_status(200);

	    return $response;
	}

	add_action('rest_api_init', function () {
	register_rest_route( 'deagor/v1', 'updateAttributes',array(
                'methods'  => 'POST',
                'callback' => 'updateAttributes'
			));
	});

	function updateAttributes($request) {

		$_params = $request->get_params();

		$_params = json_decode($_params['params'], true);
		if (!canAccess($_params)){
			$_return['status']	= 2;
			$_return['error'] 	= array(
					'code' 		=> 'ER03',
					'message'	=> 'Token error'
				);
			$response = new WP_REST_Response($_return);
		    $response->set_status(200);
		    return $response;
		} else {
			$_return['status']	= 1;
		}

		$_return['data']	= array('success' => false, 'message' => '');

	    $_sku				= @$_params['sku'];
		$_attributes 		= @$_params['attributes'];

	    if (($_sku) && ($_attributes)){
		    $query_args = array(
			    'type'		=> array('simple','variable'),
			    'limit' 	=> get_option('posts_per_page'),
			    'page' 		=> 1,
			    'sku'		=> $_sku,
			);

			$_collection = wc_get_products($query_args);
			$_isVariation= false;
			if (!$_collection){
				$query_args = array(
					'post_type'       => 'product_variation',
					'posts_per_page'  => 1,
					'fields'          => 'ids',
					'meta_query'      => array(
						array(
							'key'     => '_sku',
							'value'   => $_sku,
						),
					),
				);
				$_collection = get_posts($query_args);
				$_isVariation= true;
			}

			if ($_collection){

				$_hasUpdate = false;
				foreach ($_collection as $_product){
					if ($_isVariation){
						$_product = new WC_Product_Variation($_product);
					}

					if ($_product->sku != $_sku){
						continue;
					}

					$_hasUpdate = true;
					$_standardAttribute 	= array('weight'=>'weight','depth'=>'length','height'=>'height','width'=>'width');
					$_configurableAttribute = array();
					$product_attributes		= array();
					if (get_option('deagor_volume')){
						$_configurableAttribute['volume'] = get_option('deagor_volume');
					}
					if (get_option('deagor_ean')){
						$_configurableAttribute['ean'] = get_option('deagor_ean');
					}

					foreach($_attributes as $attribute => $value){
						if (array_key_exists($attribute, $_standardAttribute)){
							update_post_meta($_product->get_id(), '_'.$_standardAttribute[$attribute], $value);
						} elseif ((array_key_exists($attribute, $_configurableAttribute)) && (!$_isVariation)) {
							$_convertionAttribute = $_configurableAttribute[$attribute];
							if ($_convertionAttribute){
								$product_attributes[$_convertionAttribute] = array (
						            'name' => $_convertionAttribute,
						            'value' => $value,
						            'position' => 1,
						            'is_visible' => 1,
						            'is_variation' => 0,
						            'is_taxonomy' => 0
						        );
							}
						}
					}
					if ($product_attributes){
						$_currentAttribute 	= get_post_meta($_product->get_id(), '_product_attributes', true);
						$_attributeToSet	= array_merge($_currentAttribute, $product_attributes);
						update_post_meta($_product->get_id(), '_product_attributes', $_attributeToSet);
					}
				}

				if ($_hasUpdate){
					$_return['data']['success'] = true;
				    $_return['data']['message'] = 'Product was update successful';
				}


		    } else {
			    $_return['data']['message'] = 'No Product found';
		    }
	    } else {
		    $_return['data']['message'] = "'sku' and 'attributes' params are required.";
	    }

		$_data = json_encode($_return['data']);
		$_return['data'] = array();
		$_return['data'] = $_data;

		$response = new WP_REST_Response($_return);
	    $response->set_status(200);

	    return $response;
	}

	add_action('rest_api_init', function () {
	register_rest_route( 'deagor/v1', 'trackingOrder',array(
                'methods'  => 'POST',
                'callback' => 'trackingOrder'
			));
	});

	function trackingOrder($request) {

		$_params = $request->get_params();
		$_params = json_decode($_params['params'], true);

		if (!canAccess($_params)){
			$_return['status']	= 2;
			$_return['error'] 	= array(
					'code' 		=> 'ER03',
					'message'	=> 'Token error '.$pp['token']
				);
			$response = new WP_REST_Response($_return);
		    $response->set_status(200);
		    return $response;
		} else {
			$_return['status']	= 1;
		}

		$_return['data']	= array('success' => false, 'message' => '');

	    $_orderId			= @$_params['shipping_increment'];
		$_tracking 			= @$_params['tracking'];
		$_carrier 			= @$_params['carrier'];

	    if (($_orderId) && ($_tracking) && ($_carrier)){
		    $query_args = array(
			    'limit' 	=> get_option('posts_per_page'),
			    'page' 		=> 1,
			    'post__in' 	=> array($_orderId),
			);

			$_collection = wc_get_orders($query_args);

		    if ($_collection){

				$_order = new WC_Order($_orderId);
				$_status = get_option('deagor_tracked');
				if (!$_status){
					$_status = 'completed';
				}
			    $_order->update_status($_status, 'Tracking '.$_carrier.': '.$_tracking.' was updated by Deagor');
			    $_order->add_order_note('Tracking '.$_carrier.': '.$_tracking.' was updated by Deagor');

			    if (function_exists('wc_st_add_tracking_number')) {
					wc_st_add_tracking_number( $_orderId, $_tracking, $_carrier, date('Y-m-d H:i:s'), '');
				}

			    $_return['data']['success'] = true;
			    $_return['data']['message'] = 'Tracking was created successful';

		    } else {
			    $_return['data']['message'] = 'No OrderID found';
		    }
	    } else {
		    $_return['data']['message'] = 'No OrderID o Items parsed';
	    }

		$_data = json_encode($_return['data']);
		$_return['data'] = array();
		$_return['data'] = $_data;

		$response = new WP_REST_Response($_return);
	    $response->set_status(200);

	    return $response;
	}

	add_action('rest_api_init', function () {
	register_rest_route( 'deagor/v1', 'shipOrder',array(
                'methods'  => 'POST',
                'callback' => 'shipOrder'
			));
	});

	function shipOrder($request) {

		$_params = $request->get_params();
		$_params = json_decode($_params['params'], true);
		if (!canAccess($_params)){
			$_return['status']	= 2;
			$_return['error'] 	= array(
					'code' 		=> 'ER03',
					'message'	=> 'Token error'
				);
			$response = new WP_REST_Response($_return);
		    $response->set_status(200);
		    return $response;
		} else {
			$_return['status']	= 1;
		}

		$_return['data']	= array('success' => false, 'message' => '');
	    $_orderId 			= @$_params['ecommerce_id'];
	    $_orderItems 		= @$_params['items'];

	    if (($_orderId) && ($_orderItems)){
		    $query_args = array(
			    'limit' 	=> get_option('posts_per_page'),
			    'page' 		=> 1,
			    'post__in' 	=> array($_orderId),
			);

			$_collection = wc_get_orders($query_args);

		    if ($_collection){

				$_order = new WC_Order($_orderId);

				$_status = get_option('deagor_shipped');
				if (!$_status){
					$_status = 'completed';
				}
			    $_order->update_status($_status, 'Shipping created by Deagor');
			    $_return['data']['success'] = true;
			    $_return['data']['ec_shipping_increment'] = $_orderId;
			    $_return['data']['message'] = 'Shipping was created successful';

		    } else {
			    $_return['data']['message'] = 'No OrderID found';
		    }
	    } else {
		    $_return['data']['message'] = 'No OrderID o Items parsed';
	    }

		$_data = json_encode($_return['data']);
		$_return['data'] = array();
		$_return['data'] = $_data;

		$response = new WP_REST_Response($_return);
	    $response->set_status(200);

	    return $response;
	}

	add_action('rest_api_init', function () {
	register_rest_route( 'deagor/v1', 'cancelOrder',array(
                'methods'  => 'POST',
                'callback' => 'cancelOrder'
			));
	});

	function cancelOrder($request) {

		$_params = $request->get_params();
		$_params = json_decode($_params['params'], true);
		if (!canAccess($_params)){
			$_return['status']	= 2;
			$_return['error'] 	= array(
					'code' 		=> 'ER03',
					'message'	=> 'Token error'
				);
			$response = new WP_REST_Response($_return);
		    $response->set_status(200);
		    return $response;
		} else {
			$_return['status']	= 1;
		}

		$_return['data']	= array('success' => false, 'message' => '');
	    $_orderId 			= @$_params['order_id'];

	    if ($_orderId){
		    $query_args = array(
			    'limit' 	=> get_option('posts_per_page'),
			    'page' 		=> 1,
			    'post__in' 	=> array($_orderId),
			);

			$_collection = wc_get_orders($query_args);

		    if ($_collection){

				$_order = new WC_Order($_orderId);
			    $_order->update_status('cancelled', 'Order Cancelled by Deagor');
			    $_return['data']['success'] = true;
			    $_return['data']['message'] = 'Order Successfully canceled';

		    } else {
			    $_return['data']['message'] = 'No OrderID found';
		    }
	    } else {
		    $_return['data']['message'] = 'No OrderID parsed';
	    }

		$_data = json_encode($_return['data']);
		$_return['data'] = array();
		$_return['data'] = $_data;

		$response = new WP_REST_Response($_return);
	    $response->set_status(200);

	    return $response;
	}


	add_action('rest_api_init', function () {
	register_rest_route( 'deagor/v1', 'getOrderItems',array(
                'methods'  => 'POST',
                'callback' => 'getOrderItems'
			));
	});

	function getOrderItems($request) {

		$_params = $request->get_params();
		$_params = json_decode($_params['params'], true);

		if (!canAccess($_params)){
			$_return['status']	= 2;
			$_return['error'] 	= array(
					'code' 		=> 'ER03',
					'message'	=> 'Token error'
				);
			$response = new WP_REST_Response($_return);
		    $response->set_status(200);
		    return $response;
		} else {
			$_return['status']	= 1;
		}

		$_orderId = @$_params['ecommerce_id'];
		if (!$_orderId) {
			$_return['status']	= 2;
			$_return['error'] 	= array(
					'code' 		=> 'ER03',
					'message'	=> 'No ID Parsed'
				);
			$response = new WP_REST_Response($_return);
		    $response->set_status(200);
		    return $response;
		}

		$query_args = array(
		    'limit' 	=> get_option('posts_per_page'),
		    'page' 		=> $_page,
		    'post__in' 	=> array($_orderId),
		);

		$_collection = wc_get_orders($query_args);
		$_isLast 	 = true;

		if (!count($_collection)){
			$_return['data']['data'] = array();
			$_isLast 	= true;
		}

		foreach ($_collection as $_idx => $_order){

			if ($_order->created_via == 'admin') {
				continue;
			}

			foreach ($_order->get_items() as $_key => $item) {

				//print_r($item);
				//$product 	= $item->get_product();
				$product =  wc_get_product($item->get_product_id());


				$item_qty_refunded = abs($_order->get_qty_refunded_for_item($item->get_id()));
				if ($item_qty_refunded){
					$item_total_refunded = $_order->get_total_refunded_for_item($item->get_id());
					$_qty = $item->get_quantity()-$item_qty_refunded;
				} else {
					$_qty = $item->get_quantity();
				}

				if (!$_qty){
					continue;
				}

				$_basePrice = ($item->get_total()+$item->get_subtotal_tax())/$_qty;

				$_return['data']['data'][$_key]['sku'] 		= $product->sku;
				$_return['data']['data'][$_key]['price']	= number_format($_basePrice,2,'.','');
				$_return['data']['data'][$_key]['qty'] 		= $_qty;
				$_return['data']['data'][$_key]['name'] 	= $item->get_name();
				$_return['data']['data'][$_key]['ec_row_id']= $_key;
				$_return['data']['data'][$_key]['actualqty']= $product->stock_quantity;
				$_return['data']['data'][$_key]['image'] 	= get_the_post_thumbnail_url($product->get_id());
				$_return['data']['data'][$_key]['channel_product_id'] 	= $product->get_id();

				if (get_option('deagor_ean') == 'wpm_gtin_code'){
					$_return['data']['data'][$_key]['ean'] = $product->get_meta('_wpm_gtin_code');
				} elseif (get_option('deagor_ean') == 'hwp_product_gtin'){
					$_return['data']['data'][$_key]['ean'] = $product->get_meta('hwp_product_gtin');
				} else {
					$_return['data']['data'][$_key]['ean'] = get_option('deagor_ean') ? $product->get_attribute(get_option('deagor_ean')) : '';
				}

				$_return['data']['data'][$_key]['model'] = get_option('deagor_model') ? $product->get_attribute(get_option('deagor_model')) : '';

				$_return['data']['data'][$_key]['cod_forn1'] = get_option('deagor_forn1') ? $product->get_attribute(get_option('deagor_forn1')) : '';
				$_return['data']['data'][$_key]['cod_forn2'] = get_option('deagor_forn2') ? $product->get_attribute(get_option('deagor_forn2')) : '';
				$_return['data']['data'][$_key]['cod_forn3'] = get_option('deagor_forn3') ? $product->get_attribute(get_option('deagor_forn3')) : '';
				$_return['data']['data'][$_key]['cod_forn4'] = get_option('deagor_forn4') ? $product->get_attribute(get_option('deagor_forn4')) : '';


				$_return['data']['data'][$_key]['weight']	= $product->weight ? $product->weight : 0;

				if ($_volumeAttribute = get_option('deagor_volume')){
					$_return['data']['data'][$_key]['volume']	= $product->get_attribute($_volumeAttribute);
				} else {
					if (($product->height) && ($product->width) && ($product->length)){
						$_return['data']['data'][$_key]['volume']	= ($product->height*$product->width*$product->length)/1000000;
					} else {
						$_return['data']['data'][$_key]['volume']	= 0;
					}
				}

				$_return['data']['data'][$_key]['height'] 	= $product->height ? $product->height : 0;
				$_return['data']['data'][$_key]['width'] 	= $product->width ? $product->width : 0;
				$_return['data']['data'][$_key]['length'] 	= $product->length ? $product->length : 0;

				if ($product->get_type() == 'variable'){

					$handle		= new WC_Product_Variable($item->get_product_id());
					$variations	= $handle->get_children();

					foreach ($variations as $value) {

						if ($value != $item->get_variation_id()){
							continue;
						}
					    $single_variation = new WC_Product_Variation($value);

					    $_variation = implode(" / ", $single_variation->get_variation_attributes());
					    if (($single_variation->sku) && ($single_variation->sku != $product->sku)){
						    $_sku = $single_variation->sku;
					    } else {
						    $_sku = $product->sku.'_'.$_variation;
					    }

						$_return['data']['data'][$_key]['sku'] = $_sku;

					    if ($single_variation->height){
							$_return['data']['data'][$_key]['height'] 	= $single_variation->height;
					    }
					    if ($single_variation->width){
							$_return['data']['data'][$_key]['width'] 	= $single_variation->width;
					    }
					    if ($single_variation->length){
							$_return['data']['data'][$_key]['length'] 	= $single_variation->length;
					    }
					    if ($single_variation->weight){
							$_return['data']['data'][$_key]['weight'] 	= $single_variation->weight;
					    }
					    if (($single_variation->height) && ($single_variation->width) && ($single_variation->length)){
							$_return['data']['data'][$_key]['volume']	= ($single_variation->height*$single_variation->width*$single_variation->length)/1000000;
						}
						if (get_option('deagor_ean') == 'wpm_gtin_code'){
							if ($single_variation->get_meta('_wpm_gtin_code')){
								$_return['data']['data'][$_key]['ean'] = $single_variation->get_meta('_wpm_gtin_code');
							}
						} elseif (get_option('deagor_ean') == 'hwp_product_gtin'){
							if ($single_variation->get_meta('hwp_var_gtin')){
								$_return['data']['data'][$_key]['ean'] = $single_variation->get_meta('hwp_var_gtin');
							}
						}
					}

				}

			}


		}

		$_return['data']['is_last'] = $_isLast;
		$_return['data']['dataset'] = $_params;
		$_data = json_encode($_return['data']);
		$_return['data'] = array();
		$_return['data'] = $_data;

		$response = new WP_REST_Response($_return);
	    $response->set_status(200);

	    return $response;
	}

	add_action('rest_api_init', function () {
	register_rest_route( 'deagor/v1', 'getOrders',array(
                'methods'  => 'POST',
                'callback' => 'getOrders'
			));
	});

	function cleanAddressString($_string){
		$_string = trim(strtoupper($_string));
		return $_string;
	}

	function decodeStreetHelp($_street){
		$_numberFound 	= false;
		$_number		= null;

		for($i = strlen($_street); $i >= 0; $i--){
			$_char = substr($_street, $i, 1);
			if(is_numeric($_char)){
				$_numberFound 	= true;
				$_number 		= $_char.$_number;
			}elseif(!is_numeric($_char) && !$_numberFound){
				$_number = $_char.$_number;
			}elseif($_char == '/' || $_char == "\\"){
				$_number = $_char.$_number;
			}else{
				break;
			}
		}
		if($_number != $_street){
			$_street = trim(str_replace($_number, '', $_street));

			if(strpos($_street.",", ",,") != false){
				$_street = str_replace(",,", "", $_street.",");
			}

			return array(
				'street' => $_street,
				'number' => $_number
			);
		}
		return false;
	}

	function decodeStreet($_shipment) {
		$_streets = $_shipment['street_1'];

		if(count($_streets) == 1){
			$_decoded = decodeStreetHelp($_streets[0]);
			if($_decoded){
				$_shipment['street_1'] 	= $_decoded['street'];
				$_shipment['number'] 	= $_decoded['number'];
			} else {
				$_shipment['street_1'] 	= $_shipment['street_1'][0];
			}
		}else{
			$_hasDeoded = false;
			foreach($_streets as $_street){
				if(!$_hasDeoded){
					if($_decoded = decodeStreetHelp($_street)){
						$_shipment['street_1'] 	= $_decoded['street'];
						$_shipment['number'] 	= $_decoded['number'];
						$_hasDeoded 			= true;
					}else{
						$_shipment['notes'] .= $_shipment['notes'] ? ' '.$_street : $_street;
					}
				}else{
					$_shipment['notes'] .= $_shipment['notes'] ? ' '.$_street : $_street;
				}
			}
		}
		if (is_array($_shipment['street_1'])) {
			$streets2 = $_shipment['street_1'];
			$_shipment['street_1'] = '';
			foreach ($streets2 as $_ship){
				if (is_numeric($_ship)) {
					$_shipment['number'] 	= $_ship;
				} else {
					$_shipment['street_1'] .= $_ship;
				}
			}
		}
		$_array_key_co = array('presso','c/o');
		foreach ($_array_key_co as $co) {
			if (strpos($_shipment['number'], $co) !== false) {
				$_shipment['notes'] .= $co.' '.substr(strstr($_shipment['number'], $co), strlen($co));
				$_shipment['number'] = substr($_shipment['number'], 0, strpos($_shipment['number'], $co));
			}
		}

		return $_shipment;

	}

	function cleanShippingMethod($_methods){
		$_methods = preg_replace("/[^A-Za-z0-9?! ]/","",$_methods);
		$_methods = str_replace(' ','_', $_methods);
		$_methods = str_replace('__','_', $_methods);
		$_methods = strtolower($_methods);
		$_methods = substr($_methods,0,50);
		return $_methods;
	}

	function getOrders($request) {

		$_params = $request->get_params();
		$_params = json_decode($_params['params'], true);
		if (!canAccess($_params)){
			$_return['status']	= 2;
			$_return['error'] 	= array(
					'code' 		=> 'ER03',
					'message'	=> 'Token error'
				);
			$response = new WP_REST_Response($_return);
		    $response->set_status(200);
		    return $response;
		} else {
			$_return['status']	= 1;
		}

		$dayToSync  	= (int)get_option('deagor_daytosync');
		if (!$dayToSync){
			$dayToSync = 15;
		}
		$_status		= get_option('deagor_statussend');

		$_page = (intval($_params['set'])+1);

		$query_args = array(
		    'status'    => $_status,
		    'limit' 	=> get_option('posts_per_page'),
		    'page' 		=> $_page,
		    'date_created' => '>='.date('Y-m-d', strtotime('-'.(int)$dayToSync.' days')),
		);

		if (($orderId = $_params['order_id']) || ($orderId = $_params['order_increment']) || ($orderId = $_params['ecommerce_id'])) {
			$query_args['post__in'] = array($orderId);
			$query_args['date_created'] = '';
			unset($query_args['status']);
		}

		$_collection = wc_get_orders($query_args);

		if ($orderId){
			$_isLast 	= true;
		} else {
			$_lastPage 	= ceil(count($_collection)/get_option('posts_per_page'));
			$_isLast 	= $_page == $_lastPage ? true : false;
		}

		if (!count($_collection)){
			$_return['data']['data'] = array();
			$_isLast 	= true;
		}

		$_allRegion = WC()->countries->get_states();

		foreach ($_collection as $_idx => $_order){

			if ($_order->created_via == 'admin') {
				continue;
			}

			//print_r($_order);
			$_firstname = $_order->get_shipping_first_name() ? $_order->get_shipping_first_name() : $_order->get_billing_first_name();
			$_lastname 	= $_order->get_shipping_last_name() ? $_order->get_shipping_last_name() : $_order->get_billing_last_name();
			$_company	= $_order->get_shipping_company() ? $_order->get_shipping_company() : $_order->get_billing_company();
			$_country	= $_order->get_shipping_country() ? $_order->get_shipping_country() : $_order->get_billing_country();
			$_regionCode= $_order->get_shipping_state() ? $_order->get_shipping_state() : $_order->get_billing_state();

			if (array_key_exists($_country, $_allRegion)){
				if (array_key_exists($_regionCode, $_allRegion[$_country])){
					$_region = $_allRegion[$_country][$_regionCode];
				} else {
					$_region = $_regionCode;
				}
			} else {
				$_region = $_regionCode;
			}

			$_city		= $_order->get_shipping_city() ? $_order->get_shipping_city() : $_order->get_billing_city();
			$_postcode	= $_order->get_shipping_postcode() ? $_order->get_shipping_postcode() : $_order->get_billing_postcode();
			$_street_1	= array();
			$_street_1[] = $_order->get_shipping_address_1() ? $_order->get_shipping_address_1() : $_order->get_billing_address_1();
			$_street_2	= $_order->get_shipping_address_2() ? $_order->get_shipping_address_2() : $_order->get_billing_address_2();
			if ($_street_2){
				$_street_1[0] = trim($_street_1[0].' '.$_street_2);
			}
			$_phone		= $_order->get_billing_phone();

			$_shipment = array();

			$_shipment['firstname'] = cleanAddressString($_firstname);
			$_shipment['status'] 	= wc_get_order_status_name($_order->status);
			$_shipment['lastname'] 	= cleanAddressString($_lastname);
			$_shipment['company'] 	= cleanAddressString($_company);
			$_shipment['country'] 	= $_country;
			$_shipment['region'] 	= cleanAddressString($_region);
			$_shipment['region_code']= cleanAddressString($_regionCode);
			$_shipment['city'] 		= cleanAddressString($_city);
			$_shipment['postcode'] 	= $_postcode;
			$_shipment['street_1'] 	= $_street_1;
			$_shipment['number'] 	= null;
			$_shipment['mobile'] 	= str_replace(' ', '', $_phone);
			$_shipment['telephone'] = '';
			$_shipment['notes'] 	= cleanAddressString($_order->customer_note);

			$_decodedStreet 		= decodeStreet($_shipment);
			$_shipment['street_1']	= cleanAddressString($_decodedStreet['street_1']);
			$_shipment['number']	= cleanAddressString($_decodedStreet['number']);
			$_shipment['notes']		= cleanAddressString($_decodedStreet['notes']);

			if ($_refunded = $_order->get_total_refunded()){
				$_grandTotal = $_order->total-$_refunded;
			} else {
				$_grandTotal = $_order->total;
			}

			$_return['data']['data'][$_idx]						= $_shipment;
			$_return['data']['data'][$_idx]['ec_customer_id'] 	= $_order->customer_id;
			$_return['data']['data'][$_idx]['order_created_at']	= $_order->order_date;
			$_return['data']['data'][$_idx]['ecommerce_id'] 	= $_order->get_ID();
			$_return['data']['data'][$_idx]['grand_total'] 		= $_grandTotal;
			$_return['data']['data'][$_idx]['email'] 			= strtolower(cleanAddressString($_order->get_billing_email()));
			$_return['data']['data'][$_idx]['erp_id']			= $_order->get_ID();

			// PAYMENT
			$_return['data']['data'][$_idx]['payment_method'] 	= $_order->payment_method;
			$_return['data']['data'][$_idx]['payment_method_title'] = $_order->payment_method_title;

			// SHIPPING
			foreach($_order->get_items('shipping') as $item_id => $shipping_item_obj){
				$shipping_method_ec = $shipping_item_obj->get_method_id();
				$shipping_method 	= $shipping_item_obj->get_name();
			}

			if (!$shipping_method){
				$shipping_method = 'No Shipping Method';
				$shipping_method_ec = 'No Shipping Method';
			}

			$_return['data']['data'][$_idx]['shipping_method'] = cleanShippingMethod($shipping_method);
			$_return['data']['data'][$_idx]['shipping_method_ec'] = $shipping_method_ec;
			$_return['data']['data'][$_idx]['shipping_method_title'] = $shipping_method;
			$_return['data']['data'][$_idx]['shipping_method_title_ec'] = $shipping_method;

		}

		$_return['data']['is_last'] = $_isLast;
		$_return['data']['dataset'] = $_params;
		$_data = json_encode($_return['data']);
		$_return['data'] = array();
		$_return['data'] = $_data;

		$response = new WP_REST_Response($_return);
	    $response->set_status(200);

	    return $response;
	}


	add_action('rest_api_init', function () {
	register_rest_route( 'deagor/v1', 'getProducts',array(
                'methods'  => 'POST',
                'callback' => 'getProducts'
			));
	});

	function getProducts($request) {

		$_params = $request->get_params();
		$_params = json_decode($_params['params'], true);

		if (!canAccess($_params)){
			$_return['status']	= 2;
			$_return['error'] 	= array(
					'code' 		=> 'ER03',
					'message'	=> 'Token error'
				);
			$response = new WP_REST_Response($_return);
		    $response->set_status(200);
		    return $response;
		} else {
			$_return['status']	= 1;
		}


		$_page = (intval($_params['set'])+1);

		$query_args = array(
		    'status'    => 'publish',
		    'type'		=> array('simple','variable'),
		    'catalog_visibility' => 'visible',
		    'limit' 	=> 100000,
		    'page' 		=> $_page,
		    'date_modified' => ''
		);

		if ($_dayToUpdated = $_params['lastdays']) {
			$query_args['date_modified'] = '>='.date('Y-m-d', strtotime('-'.(int)$_dayToUpdated.' days'));
		}

		if ($specific_sku = $_params['products']){
			$query_args['sku'] = $specific_sku;
			unset($query_args['status']);
			unset($query_args['catalog_visibility']);
		}

		$_collection = wc_get_products($query_args);

		if ($specific_sku){
			$_isLast	= true;
		} else {
			$_lastPage 	= ceil(count($_collection)/get_option('posts_per_page'));
			$_isLast 	= $_page == $_lastPage ? true : false;
		}

		if (!count($_collection)){
			$_return['data']['data'] = array();
			$_isLast 	= true;
		}

		foreach($_collection as $key => $product){
			if ($product->get_type() != 'variable'){
				if (!$product->sku){
					continue;
				}
			}

			$_return['data']['data'][$key]['sku'] 	= $product->sku;
			if (get_option('deagor_ean') == 'wpm_gtin_code'){
				$_return['data']['data'][$key]['ean'] = $product->get_meta('_wpm_gtin_code');
			} elseif (get_option('deagor_ean') == 'hwp_product_gtin'){
				$_return['data']['data'][$key]['ean'] = $product->get_meta('hwp_product_gtin');
			} elseif (get_option('deagor_ean') == 'variable_alg_ean_1'){
				$_return['data']['data'][$key]['ean'] = $product->get_meta('_alg_ean');
			} else {
				$_return['data']['data'][$key]['ean'] = get_option('deagor_ean') ? $product->get_attribute(get_option('deagor_ean')) : '';
			}

			$_return['data']['data'][$key]['channel_product_id'] = $product->get_id();
			$_return['data']['data'][$key]['name'] 	= $product->name;

			$_return['data']['data'][$key]['qty'] 	= $product->manage_stock ? $product->stock_quantity : 0;

			$_return['data']['data'][$key]['model'] = get_option('deagor_model') ? $product->get_attribute(get_option('deagor_model')) : '';

			$_return['data']['data'][$key]['cod_forn1'] = get_option('deagor_forn1') ? $product->get_attribute(get_option('deagor_forn1')) : '';
			$_return['data']['data'][$key]['cod_forn2'] = get_option('deagor_forn2') ? $product->get_attribute(get_option('deagor_forn2')) : '';
			$_return['data']['data'][$key]['cod_forn3'] = get_option('deagor_forn3') ? $product->get_attribute(get_option('deagor_forn3')) : '';
			$_return['data']['data'][$key]['cod_forn4'] = get_option('deagor_forn4') ? $product->get_attribute(get_option('deagor_forn4')) : '';


			$_return['data']['data'][$key]['weight']	= $product->weight ? $product->weight : 0;

			if ($_volumeAttribute = get_option('deagor_volume')){
				if ($product->get_attribute($_volumeAttribute)){
					$_return['data']['data'][$key]['volume']	= $product->get_attribute($_volumeAttribute);
				} elseif (($product->height) && ($product->width) && ($product->length)){
					$_return['data']['data'][$key]['volume']	= ($product->height*$product->width*$product->length)/1000000;
				}
			} else {
				if (($product->height) && ($product->width) && ($product->length)){
					$_return['data']['data'][$key]['volume']	= ($product->height*$product->width*$product->length)/1000000;
				} else {
					$_return['data']['data'][$key]['volume']	= 0;
				}
			}

			$_return['data']['data'][$key]['height'] 	= $product->height ? $product->height : 0;
			$_return['data']['data'][$key]['width'] 	= $product->width ? $product->width : 0;
			$_return['data']['data'][$key]['length'] 	= $product->length ? $product->length : 0;

			$_return['data']['data'][$key]['cost'] 		= get_option('deagor_cost') ? $product->get_attribute(get_option('deagor_costs')) : 0;

			$_return['data']['data'][$key]['price'] 	= $product->price;
			$_return['data']['data'][$key]['special_price'] = 0;

			$_return['data']['data'][$key]['status'] 	= 1;
			$_return['data']['data'][$key]['image'] 	= get_the_post_thumbnail_url($product->get_id());

			$_taxRate = WC_Tax::get_rates($product->get_tax_class());
			$_tax 	= '';
			foreach ($_taxRate as $_rate){
				$_tax = $_rate['rate'];
				break;
			}
			$_return['data']['data'][$key]['tax'] 		= $_tax ? $_tax : 0;

			if ($product->get_type() == 'variable'){
				$handle		= new WC_Product_Variable($product->get_id());
				$variations	= $handle->get_children();
				foreach ($variations as $value) {
				    $single_variation = new WC_Product_Variation($value);

				    $_variation = implode(" / ", $single_variation->get_variation_attributes());
				    if (($single_variation->sku) && ($single_variation->sku != $product->sku)){
					    $_sku = $single_variation->sku;
				    } else {
						if (!$product->sku){
							continue;
						}
					    $_sku = $product->sku.'_'.$_variation;
				    }
				    $_return['data']['data'][$key.$_sku] 			= $_return['data']['data'][$key];
				    $_return['data']['data'][$key.$_sku]['sku'] 	= $_sku;
				    $_return['data']['data'][$key.$_sku]['price'] 	= $single_variation->price;
				    $_return['data']['data'][$key.$_sku]['qty'] 	= $single_variation->stock_quantity ? $single_variation->stock_quantity : 0;
					$_return['data']['data'][$key.$_sku]['channel_product_id']		= $single_variation->get_id();
				    if ($single_variation->height){
						$_return['data']['data'][$key.$_sku]['height'] 	= $single_variation->height;
				    }
				    if ($single_variation->width){
						$_return['data']['data'][$key.$_sku]['width'] 	= $single_variation->width;
				    }
				    if ($single_variation->length){
						$_return['data']['data'][$key.$_sku]['length'] 	= $single_variation->length;
				    }
				    if ($single_variation->weight){
						$_return['data']['data'][$key.$_sku]['weight'] 	= $single_variation->weight;
				    }
				    if (($single_variation->height) && ($single_variation->width) && ($single_variation->length)){
						$_return['data']['data'][$key.$_sku]['volume']	= ($single_variation->height*$single_variation->width*$single_variation->length)/1000000;
					}
					if (get_option('deagor_ean') == 'wpm_gtin_code'){
						if ($single_variation->get_meta('_wpm_gtin_code')){
							$_return['data']['data'][$key.$_sku]['ean'] = $single_variation->get_meta('_wpm_gtin_code');
						}
					} elseif (get_option('deagor_ean') == 'hwp_product_gtin'){
						if ($single_variation->get_meta('hwp_var_gtin')){
							$_return['data']['data'][$key.$_sku]['ean'] = $single_variation->get_meta('hwp_var_gtin');
						}
					} elseif (get_option('deagor_ean') == 'variable_alg_ean_1'){
						if ($single_variation->get_meta('_alg_ean')){
							$_return['data']['data'][$key.$_sku]['ean'] = $single_variation->get_meta('_alg_ean');
						}
					}

				}
				unset($_return['data']['data'][$key]);
			}
		}

		$_return['data']['is_last'] = $_isLast;
		$_return['data']['dataset'] = $_params;
		$_data = json_encode($_return['data']);
		$_return['data'] = array();
		$_return['data'] = $_data;

		$response = new WP_REST_Response($_return);
	    $response->set_status(200);

	    return $response;
	}

?>
